//
//  WLJSysAddressBookHander.m
//  AddressBookTest
//
//  Created by WLJ on 16/4/26.
//  Copyright © 2016年 WLJ. All rights reserved.
//

#import "WLJSysAddressBookHander.h"
#import <AddressBookUI/AddressBookUI.h>
#import <ContactsUI/ContactsUI.h>
@implementation Phone
-(instancetype)init
{
    self = [super init];
    if (self)
    {
        self.HomeLabel  = @"";
        self.MobileLabel = @"";
        self.WorkLabel = @"";
        self.IPhoneLabel = @"";
        self.MainLabel = @"";
        self.HomeFAXLabel = @"";
        self.WorkFAXLabel = @"";
        self.OtherFAXLabel = @"";
        self.PagerLabel = @"";
    }
    return self;
}
@end
@implementation PeopleModel
-(instancetype)init
{
    self = [super init];
    if (self)
    {
        self.FirstName = @"";
        self.LastName = @"";
//        self.MiddleName = @"";
//        self.Organization = @"";
//        self.Department = @"";
//        self.JobTitle = @"";
        //self.Birthday = @"";
        self.phone = [[Phone alloc]init];
    }
    return self;
}
@end
@interface WLJSysAddressBookHander()<ABPeoplePickerNavigationControllerDelegate,CNContactPickerDelegate>
@end
@implementation WLJSysAddressBookHander
static id _instace;

+ (id)allocWithZone:(struct _NSZone *)zone
{
    static dispatch_once_t onceToken;
    dispatch_once(&onceToken, ^{
        _instace = [super allocWithZone:zone];
    });
    return _instace;
}
- (id)copyWithZone:(NSZone *)zone
{
    return _instace;
}
+ (instancetype)sharedHelper
{
    static dispatch_once_t onceToken;
    dispatch_once(&onceToken, ^{
        _instace = [[self alloc] init];
    });
    //[_instace GetSysAddress];
    return _instace;
}
-(void)setDidSeletedPeople:(void (^)(PeopleModel *))didSeletedPeople
{
    [_instace GetSysAddress];
    _didSeletedPeople = didSeletedPeople;
}
-(void)SavePeople:(PeopleModel*)peopleModel CompletHander:(void(^)(BOOL state))completHander
{
    [[self class] GetJurisdiction:^(BOOL result) {
        if (result)
        {
            if ([UIDevice currentDevice].systemVersion.doubleValue <9.0)
            {
                if ([UIDevice currentDevice].systemVersion.doubleValue >=8.0)
                {
                    
                    ABAddressBookRef adbk=ABAddressBookCreateWithOptions(NULL, NULL);//获取本地通讯录数据库
        
                    ABRecordRef annkey=ABPersonCreate();//创建联系人
                    
                    //设置联系人的值
                        ABRecordSetValue(annkey,kABPersonFirstNameProperty,(__bridge CFTypeRef)(peopleModel.FirstName) , NULL);

                        ABRecordSetValue(annkey,kABPersonFirstNameProperty,(__bridge CFTypeRef)(peopleModel.LastName) , NULL);

                        ABRecordSetValue(annkey,kABPersonMiddleNameProperty,(__bridge CFTypeRef)(peopleModel.MiddleName) , NULL);

                        ABRecordSetValue(annkey,kABPersonOrganizationProperty,(__bridge CFTypeRef)(peopleModel.Organization) , NULL);

                        ABRecordSetValue(annkey,kABPersonDepartmentProperty,(__bridge CFTypeRef)(peopleModel.Department) , NULL);

                        ABRecordSetValue(annkey,kABPersonJobTitleProperty,(__bridge CFTypeRef)(peopleModel.JobTitle) , NULL);
                        ABRecordSetValue(annkey,kABPersonBirthdayProperty,(__bridge CFTypeRef)(peopleModel.Birthday) , NULL);
                    
                    ABMutableMultiValueRef Phone=ABMultiValueCreateMutable(kABMultiStringPropertyType);
                    //增加属性名和属性值，属性名为kABHomeLabel
                    ABMultiValueAddValueAndLabel(Phone,(__bridge CFTypeRef)(peopleModel.phone.MobileLabel),kABPersonPhoneMobileLabel,NULL);
                    ABMultiValueAddValueAndLabel(Phone,(__bridge CFTypeRef)(peopleModel.phone.IPhoneLabel),kABPersonPhoneIPhoneLabel ,NULL);
                    ABMultiValueAddValueAndLabel(Phone,(__bridge CFTypeRef)(peopleModel.phone.MainLabel),kABPersonPhoneMainLabel,NULL);
                    ABMultiValueAddValueAndLabel(Phone,(__bridge CFTypeRef)(peopleModel.phone.HomeLabel),kABPersonPhoneHomeFAXLabel,NULL);
                    ABMultiValueAddValueAndLabel(Phone,(__bridge CFTypeRef)(peopleModel.phone.WorkLabel),kABPersonPhoneWorkFAXLabel,NULL);
                    ABMultiValueAddValueAndLabel(Phone,(__bridge CFTypeRef)(peopleModel.phone.OtherFAXLabel),kABPersonPhoneOtherFAXLabel,NULL);
                    ABMultiValueAddValueAndLabel(Phone,(__bridge CFTypeRef)(peopleModel.phone.PagerLabel),kABPersonPhonePagerLabel,NULL);
                    //设置联系人的多值邮箱属性
                    ABRecordSetValue(annkey,kABPersonPhoneProperty, Phone,NULL);
                    
                    
//                    /************************************************************/
//                    NSString * searchName =[NSString stringWithFormat:@"%@%@",peopleModel.LastName,peopleModel.FirstName];
//                     NSArray *   personArray =(__bridge NSArray *)(ABAddressBookCopyPeopleWithName(adbk,(__bridge CFStringRef)(searchName)));
//                    if (personArray.count==1)
//                    {
//                        ABRecordRef  person = (__bridge ABRecordRef)([personArray firstObject]);
//                        
//                        ABRecordSetValue(person, kABPersonOrganizationProperty, (__bridge CFTypeRef)(peopleModel.Organization), NULL);
//                        ABRecordSetValue(person, kABPersonDepartmentProperty, (__bridge CFTypeRef)(peopleModel.Department), NULL);
//                        ABRecordSetValue(person, kABPersonJobTitleProperty, (__bridge CFTypeRef)(peopleModel.JobTitle), NULL);
//                        ABRecordSetValue(person, kABPersonBirthdayProperty, (__bridge CFTypeRef)(peopleModel.Birthday), NULL);
//                        ABRecordSetValue(person, kABPersonPhoneProperty,Phone, NULL);
//                    }else
//                    {
//                        ABAddressBookAddRecord(adbk, annkey, NULL); //增加联系人
//                    }
//                    
//                    /***************************************/
                 
                     ABAddressBookAddRecord(adbk, annkey, NULL); //增加联系人
                    CFRelease(Phone);//即使是在arc机制里，c对象仍需手动释放
                    if ( ABAddressBookSave(adbk, NULL))
                    {
                        if (completHander)
                        {
                            completHander(YES);
                        }
                    }else
                    {
                        if (completHander)
                        {
                            completHander(NO);
                        }
                    }
                    CFRelease(adbk);//即使是在arc机制里，c对象仍需手动释放
                    CFRelease(annkey);//即使是在arc机制里，c对象仍需手动释放
                }else
                {
                    if (completHander)
                    {
                        completHander(NO);
                    }
                }
            }else
            {
                //iOS9以上
                CNMutableContact * contact = [[CNMutableContact alloc]init];
                //设置名字
                contact.givenName = peopleModel.FirstName;
                //设置姓氏
                contact.familyName = peopleModel.LastName;
                
                CNLabeledValue *homeEmail = [CNLabeledValue labeledValueWithLabel:CNLabelHome value:@"316045346@qq.com"];
                CNLabeledValue *workEmail =[CNLabeledValue labeledValueWithLabel:CNLabelWork value:@"316045346@qq.com"];
                contact.emailAddresses = @[homeEmail,workEmail];
                contact.phoneNumbers = @[[CNLabeledValue labeledValueWithLabel:CNLabelPhoneNumberiPhone value:[CNPhoneNumber phoneNumberWithStringValue:peopleModel.phone.IPhoneLabel]],[CNLabeledValue labeledValueWithLabel:CNLabelPhoneNumberMobile value:[CNPhoneNumber phoneNumberWithStringValue:peopleModel.phone.MobileLabel]],[CNLabeledValue labeledValueWithLabel:CNLabelPhoneNumberMain value:[CNPhoneNumber phoneNumberWithStringValue:peopleModel.phone.MainLabel]],[CNLabeledValue labeledValueWithLabel:CNLabelPhoneNumberHomeFax value:[CNPhoneNumber phoneNumberWithStringValue:peopleModel.phone.HomeLabel]],[CNLabeledValue labeledValueWithLabel:CNLabelPhoneNumberWorkFax value:[CNPhoneNumber phoneNumberWithStringValue:peopleModel.phone.WorkLabel]],[CNLabeledValue labeledValueWithLabel:CNLabelPhoneNumberOtherFax value:[CNPhoneNumber phoneNumberWithStringValue:peopleModel.phone.OtherFAXLabel]],[CNLabeledValue labeledValueWithLabel:CNLabelPhoneNumberPager  value:[CNPhoneNumber phoneNumberWithStringValue:peopleModel.phone.PagerLabel]]];

//                contact.phoneNumbers = @[[CNLabeledValue labeledValueWithLabel:CNLabelPhoneNumberiPhone value:[CNPhoneNumber phoneNumberWithStringValue:peopleModel.phone.IPhoneLabel]],[CNLabeledValue labeledValueWithLabel:CNLabelPhoneNumberMobile value:[CNPhoneNumber phoneNumberWithStringValue:peopleModel.phone.MobileLabel]]];

//                NSCalendar *gregorian = [[NSCalendar alloc]
//                                         initWithCalendarIdentifier:NSCalendarIdentifierGregorian];
//                unsigned unitFlags = NSCalendarUnitYear|NSCalendarUnitMonth|NSCalendarUnitDay;
//                contact.birthday=[gregorian components:unitFlags fromDate:peopleModel.Birthday];
//                CNMutablePostalAddress * homeAdress = [[CNMutablePostalAddress alloc]init];
//                homeAdress.street = @"贝克街";
//                homeAdress.city = @"伦敦";
//                homeAdress.state = @"英国";
//                homeAdress.postalCode = @"221B";
//                contact.postalAddresses = @[[CNLabeledValue labeledValueWithLabel:CNLabelHome value:homeAdress]];

                //初始化方法
                CNSaveRequest * saveRequest = [[CNSaveRequest alloc]init];
                //添加联系人
                [saveRequest addContact:contact toContainerWithIdentifier:nil];
                
                CNContactStore * store = [[CNContactStore alloc]init];
                
                if ([store executeSaveRequest:saveRequest error:nil])
                {
                    if (completHander)
                    {
                        completHander(YES);
                    }
                }else
                {
                    if (completHander)
                    {
                        completHander(NO);
                    }
                }
                
            }
        }else
        {
            return ;
        }
    }];
}

+(void)GetJurisdiction:(void(^)(BOOL result))Jurisdiction
{
    if ([UIDevice currentDevice].systemVersion.doubleValue <9.0)
    {
        if ([UIDevice currentDevice].systemVersion.doubleValue >=8.0)
        {
            __block ABAddressBookRef addressBook = ABAddressBookCreateWithOptions(NULL, NULL);
            ABAuthorizationStatus authStatus = ABAddressBookGetAuthorizationStatus();
            if (authStatus != kABAuthorizationStatusAuthorized)
            {
                ABAddressBookRequestAccessWithCompletion(addressBook, ^(bool granted, CFErrorRef error)
             {
                 dispatch_async(dispatch_get_main_queue(), ^{
                     if (!granted||error)
                     {
                         UIAlertController * alert = [UIAlertController alertControllerWithTitle:@"APP请求获取通讯录权限" message:@"请到设置>隐私>通讯录打开本应用的权限设置" preferredStyle:UIAlertControllerStyleAlert ];
                         [alert addAction:[UIAlertAction actionWithTitle:@"好的" style:UIAlertActionStyleCancel handler:^(UIAlertAction * _Nonnull action) {
                             if (Jurisdiction)
                             {
                                 Jurisdiction(NO);
                             }
                         }]];
                         [alert addAction:[UIAlertAction actionWithTitle:@"设置" style:UIAlertActionStyleDefault handler:^(UIAlertAction *  action)
                                           {
                                               NSURL*url =[NSURL URLWithString:UIApplicationOpenSettingsURLString];
                                               if([[UIApplication sharedApplication] canOpenURL:url])
                                               {
                                                   [[UIApplication sharedApplication] openURL:url];
                                               }}]];
                         [[[[UIApplication sharedApplication] delegate] window].rootViewController  presentViewController:alert animated:YES completion:nil];
                     }else
                     {
                         if (Jurisdiction)
                         {
                             Jurisdiction(YES);
                         }
                     }
                });
             });
            }else
            {
                if (Jurisdiction)
                {
                    Jurisdiction(YES);
                };
            }
        }else
        {
            UIAlertController * alert = [UIAlertController alertControllerWithTitle:@"提示" message:@"系统版本过低,暂不支持" preferredStyle:UIAlertControllerStyleAlert ];
            [alert addAction:[UIAlertAction actionWithTitle:@"好的" style:UIAlertActionStyleDestructive handler:nil]];
            [[[[UIApplication sharedApplication] delegate] window].rootViewController  presentViewController:alert animated:YES completion:nil];
            return ;
        }
    }else
    {
        __block CNContactStore *addressBook = [[CNContactStore alloc] init];
        CNAuthorizationStatus authStatus = [CNContactStore authorizationStatusForEntityType:CNEntityTypeContacts];
        if (authStatus != CNAuthorizationStatusAuthorized)
        {
            [addressBook requestAccessForEntityType:CNEntityTypeContacts completionHandler:^(BOOL granted, NSError * _Nullable error) {
                dispatch_async(dispatch_get_main_queue(), ^{
                    if (!granted||error)
                    {
                        UIAlertController * alert = [UIAlertController alertControllerWithTitle:@"APP请求获取通讯录权限" message:@"请到设置>隐私>通讯录打开本应用的权限设置" preferredStyle:UIAlertControllerStyleAlert ];
                        [alert addAction:[UIAlertAction actionWithTitle:@"好的" style:UIAlertActionStyleCancel handler:^(UIAlertAction * _Nonnull action) {
                            if (Jurisdiction)
                            {
                                Jurisdiction(NO);
                            }
                        }]];
                        [alert addAction:[UIAlertAction actionWithTitle:@"设置" style:UIAlertActionStyleDefault handler:^(UIAlertAction *  action)
                          {
                              NSURL*url =[NSURL URLWithString:UIApplicationOpenSettingsURLString];
                              if([[UIApplication sharedApplication] canOpenURL:url])
                              {
                                  [[UIApplication sharedApplication] openURL:url];
                              }}]];
                        [[[[UIApplication sharedApplication] delegate] window].rootViewController  presentViewController:alert animated:YES completion:nil];
                    }else
                    {
                        if (Jurisdiction)
                        {
                            Jurisdiction(YES);
                        }
                    }
                });
             }];
        }else
        {
            if (Jurisdiction)
            {
                Jurisdiction(YES);
            }
        }
    }
}
-(void)GetSysAddress
{
    NSLog(@"%s",__func__);
    NSLog(@"%s",__func__);

    [[self class] GetJurisdiction:^(BOOL result) {
        if (result)
        {
            if ([UIDevice currentDevice].systemVersion.doubleValue <9.0)
            {
                if ([UIDevice currentDevice].systemVersion.doubleValue >=8.0)
                {
                    ABPeoplePickerNavigationController *peoplePicker = [[ABPeoplePickerNavigationController alloc] init];
                    peoplePicker.peoplePickerDelegate = self;
                    [[[[UIApplication sharedApplication] delegate] window].rootViewController presentViewController:peoplePicker animated:YES completion:^{
                    }];
                }else
                {
                    
                }
            }else
            {
                CNContactPickerViewController *  contactPicker = [[CNContactPickerViewController alloc]init];
                contactPicker.delegate = self;
                contactPicker.displayedPropertyKeys = @[CNContactPhoneNumbersKey];
                [[[[UIApplication sharedApplication] delegate] window].rootViewController presentViewController:contactPicker animated:YES completion:nil];
            }
        }else
        {
            return ;
        }
    }];
}
#pragma mark -- ABPeoplePickerNavigationControllerDelegate
- (void)peoplePickerNavigationController:(ABPeoplePickerNavigationController*)peoplePicker didSelectPerson:(ABRecordRef)person
{

    CFStringRef FirstName = ABRecordCopyValue(person,
                                                  kABPersonFirstNameProperty);
    CFStringRef LastName = ABRecordCopyValue(person,
                                                 kABPersonLastNameProperty);
    CFStringRef MiddleName = ABRecordCopyValue(person,
                                                 kABPersonMiddleNameProperty);
    CFStringRef Organization = ABRecordCopyValue(person,
                                                     kABPersonOrganizationProperty);
    CFStringRef Department = ABRecordCopyValue(person,
                                                   kABPersonDepartmentProperty);
    CFStringRef JobTitle = ABRecordCopyValue(person,
                                                 kABPersonJobTitleProperty);
   NSDate * Birthday =(__bridge NSDate*) ABRecordCopyValue(person,
                                                 kABPersonBirthdayProperty);
    
    ABMutableMultiValueRef phoneMulti = ABRecordCopyValue(person,
                                                           kABPersonPhoneProperty);

    PeopleModel * people = [[PeopleModel alloc]init];
    Phone * phone = people.phone;
    for (int i = 0; i < ABMultiValueGetCount(phoneMulti); i++)
    {

        NSString *aPhone = (__bridge NSString*)ABMultiValueCopyValueAtIndex(phoneMulti, i);
        NSString *aLabel = (__bridge NSString*)ABMultiValueCopyLabelAtIndex(phoneMulti, i);
        NSLog(@"PhoneLabel:%@ Phone#:%@",aLabel,aPhone);
        
            if ([aLabel isEqualToString:@"_$!<Home>!$_"])
            {
//                phone.HomeLabel = aPhone;
            }
            if ([aLabel isEqualToString:@"_$!<Mobile>!$_"])
            {
                phone.MobileLabel = aPhone;
            }
            if ([aLabel isEqualToString:@"_$!<Work>!$_"])
            {
//                phone.WorkLabel = aPhone;
            }
            if ([aLabel isEqualToString:@"iPhone" ])
            {
                phone.IPhoneLabel = aPhone;
            }
            if ([aLabel isEqualToString:@"_$!<Main>!$_"])
            {
//                phone.MainLabel=aPhone;
            }
            if ([aLabel isEqualToString:@"_$!<HomeFax>!$_"])
            {
//                phone.HomeFAXLabel = aPhone;
            }
            if ([aLabel isEqualToString:@"_$!<WorkFax>!$_"])
            {
//                phone.WorkFAXLabel =aPhone;
            }
            if ([aLabel isEqualToString:@"_$!<Other>!$_"])
            {
//                phone.OtherFAXLabel = aPhone;
            }
            if ([aLabel isEqualToString:@"_$!<Pager>!$_" ])
            {
//                phone.PagerLabel = aPhone;
            }
    }
    CFRelease(phoneMulti);
    if (self.didSeletedPeople)
    {
        people.FirstName = (__bridge NSString *)(FirstName);
        people.LastName = (__bridge NSString *)(LastName);
//        people.MiddleName = (__bridge NSString *)(MiddleName);
//        people.Organization = (__bridge NSString *)(Organization);
//        people.Department = (__bridge NSString *)(Department);
//        people.JobTitle = (__bridge NSString *)(JobTitle);
//        people.Birthday  = Birthday;
        
        people.phone = phone;
        self.didSeletedPeople(people);
    }
    [[[[UIApplication sharedApplication] delegate] window].rootViewController dismissViewControllerAnimated:YES completion:nil];
    return;
}

- (void)contactPicker:(CNContactPickerViewController *)picker didSelectContact:(CNContact *)contact
{
    if (self.didSeletedPeople)
    {
        PeopleModel * people = [[PeopleModel alloc]init];
        people.FirstName = contact.givenName;
        people.LastName = contact.familyName;
//        people.MiddleName = contact.middleName;
//        people.Organization = contact.organizationName;
//        people.Department = contact.departmentName;
//        people.JobTitle = contact.jobTitle;
        
//        [components setWeekday:2]; // Monday
//        [components setWeekdayOrdinal:1]; // The first Monday in the month
//        [components setMonth:5]; // May
//        [components setYear:2008];
        
        NSCalendar *gregorian = [[NSCalendar alloc] initWithCalendarIdentifier:NSCalendarIdentifierGregorian];
        NSDate *date = [gregorian dateFromComponents:contact.birthday];
//        people.Birthday  = date ;
        
        Phone * phone = people.phone;
        NSArray *phoneNums = contact.phoneNumbers;
        for (CNLabeledValue *labeledValue in phoneNums)
        {
            // 2.1.获取电话号码的KEY
            NSString *phoneLabel = labeledValue.label;
            
            // 2.2.获取电话号码
            CNPhoneNumber *phoneNumer = labeledValue.value;
            NSString *phoneValue = phoneNumer.stringValue;
            
            if ([phoneLabel isEqualToString:@"_$!<Home>!$_"])
            {
//                phone.HomeLabel = phoneValue;
            }
            if ([phoneLabel isEqualToString:@"_$!<Mobile>!$_"])
            {
                phone.MobileLabel = phoneValue;
            }
            if ([phoneLabel isEqualToString:@"_$!<Work>!$_"])
            {
//                phone.WorkLabel = phoneValue;
            }
            if ([phoneLabel isEqualToString:@"iPhone" ])
            {
                phone.IPhoneLabel = phoneValue;
            }
            if ([phoneLabel isEqualToString:@"_$!<Main>!$_"])
            {
//                phone.MainLabel=phoneValue;
            }
            if ([phoneLabel isEqualToString:@"_$!<HomeFax>!$_"])
            {
//                phone.HomeFAXLabel = phoneValue;
            }
            if ([phoneLabel isEqualToString:@"_$!<WorkFax>!$_"])
            {
//                phone.WorkFAXLabel =phoneValue;
            }
            if ([phoneLabel isEqualToString:@"_$!<Other>!$_"])
            {
//                phone.OtherFAXLabel = phoneValue;
            }
            if ([phoneLabel isEqualToString:@"_$!<Pager>!$_" ])
            {
//                phone.PagerLabel = phoneValue;
            }
        }
        people.phone = phone;
        self.didSeletedPeople(people);
    }

    [[[[UIApplication sharedApplication] delegate] window].rootViewController dismissViewControllerAnimated:YES completion:nil];
    return;
}

@end
